# CfnClientVpnEndpoint

Specifies a Client VPN endpoint.

A Client VPN endpoint is the resource you create and configure to enable and manage client VPN sessions. It is the destination endpoint at which all client VPN sessions are terminated.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnClientVpnEndpoint
Implements: IInspectable, IEnvironmentAware, IClientVpnEndpointRef, IConstruct, IDependable

- CloudFormation: [`AWS::EC2::ClientVpnEndpoint`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-ec2-clientvpnendpoint.html)
- Source: Generated code
- Type last changed: v2.275.0 · 26 Oct 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_ec2 as ec2 } from 'aws-cdk-lib';
const cfnClientVpnEndpoint = new ec2.CfnClientVpnEndpoint(this, 'MyCfnClientVpnEndpoint', {
  authenticationOptions: [{
    type: 'type',

    // the properties below are optional
    activeDirectory: {
      directoryId: 'directoryId',
    },
    federatedAuthentication: {
      samlProviderArn: 'samlProviderArn',

      // the properties below are optional
      selfServiceSamlProviderArn: 'selfServiceSamlProviderArn',
    },
    mutualAuthentication: {
      clientRootCertificateChainArn: 'clientRootCertificateChainArn',
    },
  }],
  connectionLogOptions: {
    enabled: false,

    // the properties below are optional
    cloudwatchLogGroup: 'cloudwatchLogGroup',
    cloudwatchLogStream: 'cloudwatchLogStream',
    includeAuthorizationPolicyContext: false,
  },
  serverCertificateArn: 'serverCertificateArn',

  // the properties below are optional
  authorizationPolicy: {
    policyDocument: 'policyDocument',

    // the properties below are optional
    description: 'description',
    shadowMode: 'shadowMode',
  },
  clientCidrBlock: 'clientCidrBlock',
  clientConnectOptions: {
    enabled: false,

    // the properties below are optional
    lambdaFunctionArn: 'lambdaFunctionArn',
  },
  clientLoginBannerOptions: {
    enabled: false,

    // the properties below are optional
    bannerText: 'bannerText',
  },
  clientRouteEnforcementOptions: {
    enforced: false,
  },
  description: 'description',
  devicePostureOptions: {
    enabled: false,
    trustProviders: [{
      tenantId: 'tenantId',
      trustProviderType: 'trustProviderType',

      // the properties below are optional
      publicSigningKeyUrl: 'publicSigningKeyUrl',
    }],
  },
  disconnectOnSessionTimeout: false,
  dnsServers: ['dnsServers'],
  endpointIpAddressType: 'endpointIpAddressType',
  securityGroupIds: ['securityGroupIds'],
  selfServicePortal: 'selfServicePortal',
  sessionTimeoutHours: 123,
  splitTunnel: false,
  tagSpecifications: [{
    resourceType: 'resourceType',
    tags: [{
      key: 'key',
      value: 'value',
    }],
  }],
  trafficIpAddressType: 'trafficIpAddressType',
  transitGatewayConfiguration: {
    transitGatewayId: 'transitGatewayId',

    // the properties below are optional
    availabilityZoneIds: ['availabilityZoneIds'],
    availabilityZones: ['availabilityZones'],
  },
  transportProtocol: 'transportProtocol',
  vpcId: 'vpcId',
  vpnPort: 123,
});
```

## Initializer

```ts
new CfnClientVpnEndpoint(scope: Construct, id: string, props: CfnClientVpnEndpointProps)
```

## Construct Props

- `authenticationOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientAuthenticationRequestProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientAuthenticationRequestProperty.html)[] (required) — Information about the authentication method to be used to authenticate clients.

- `authorizationPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.AuthorizationPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.AuthorizationPolicyProperty.html)

- `clientCidrBlock`: string — The IPv4 address range, in CIDR notation, from which to assign client IP addresses.

  The address range cannot overlap with the local CIDR of the VPC in which the associated subnet is located, or the routes that you add manually. The address range cannot be changed after the Client VPN endpoint has been created. Client CIDR range must have a size of at least /22 and must not be greater than /12.

- `clientConnectOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientConnectOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientConnectOptionsProperty.html) — The options for managing connection authorization for new client connections.

- `clientLoginBannerOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientLoginBannerOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientLoginBannerOptionsProperty.html) — Options for enabling a customizable text banner that will be displayed on AWS provided clients when a VPN session is established.

- `clientRouteEnforcementOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientRouteEnforcementOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientRouteEnforcementOptionsProperty.html) — Client route enforcement is a feature of the Client VPN service that helps enforce administrator defined routes on devices connected through the VPN.

  T his feature helps improve your security posture by ensuring that network traffic originating from a connected client is not inadvertently sent outside the VPN tunnel.

  Client route enforcement works by monitoring the route table of a connected device for routing policy changes to the VPN connection. If the feature detects any VPN routing policy modifications, it will automatically force an update to the route table, reverting it back to the expected route configurations.

- `connectionLogOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ConnectionLogOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ConnectionLogOptionsProperty.html) (required) — Information about the client connection logging options.

  If you enable client connection logging, data about client connections is sent to a Cloudwatch Logs log stream. The following information is logged:

  - Client connection requests
  - Client connection results (successful and unsuccessful)
  - Reasons for unsuccessful client connection requests
  - Client connection termination time

- `description`: string — A brief description of the Client VPN endpoint.

- `devicePostureOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.DevicePostureOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.DevicePostureOptionsProperty.html)

- `disconnectOnSessionTimeout`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the client VPN session is disconnected after the maximum `sessionTimeoutHours` is reached.

  If `true` , users are prompted to reconnect client VPN. If `false` , client VPN attempts to reconnect automatically. The default value is `true` .

- `dnsServers`: string[] — Information about the DNS servers to be used for DNS resolution.

  A Client VPN endpoint can have up to two DNS servers. If no DNS server is specified, the DNS address configured on the device is used for the DNS server.

- `endpointIpAddressType`: string — The IP address type of the Client VPN endpoint.

  Possible values are `ipv4` for IPv4 addressing only, `ipv6` for IPv6 addressing only, or `dual-stack` for both IPv4 and IPv6 addressing.

- `securityGroupIds`: string[] — The IDs of one or more security groups to apply to the target network.

  You must also specify the ID of the VPC that contains the security groups.

- `selfServicePortal`: string — Specify whether to enable the self-service portal for the Client VPN endpoint.

  Default Value: `enabled`

- `serverCertificateArn`: string (required) — The ARN of the server certificate.

  For more information, see the [Certificate Manager User Guide](https://docs.aws.amazon.com/acm/latest/userguide/) .

- `sessionTimeoutHours`: number — The maximum VPN session duration time in hours.

  Valid values: `8 | 10 | 12 | 24`

  Default value: `24`

- `splitTunnel`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether split-tunnel is enabled on the AWS Client VPN endpoint.

  By default, split-tunnel on a VPN endpoint is disabled.

  For information about split-tunnel VPN endpoints, see [Split-tunnel AWS Client VPN endpoint](https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html) in the *AWS Client VPN Administrator Guide* .

- `tagSpecifications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.TagSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.TagSpecificationProperty.html)[] — The tags to apply to the Client VPN endpoint during creation.

- `trafficIpAddressType`: string — The IP address type of the Client VPN endpoint.

  Possible values are either `ipv4` for IPv4 addressing only, `ipv6` for IPv6 addressing only, or `dual-stack` for both IPv4 and IPv6 addressing.

- `transitGatewayConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.TransitGatewayConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.TransitGatewayConfigurationProperty.html)

- `transportProtocol`: string — The transport protocol to be used by the VPN session.

  Default value: `udp`

- `vpcId`: string — The ID of the VPC to associate with the Client VPN endpoint.

  If no security group IDs are specified in the request, the default security group for the VPC is applied.

- `vpnPort`: number — The port number to assign to the Client VPN endpoint for TCP and UDP traffic.

  Valid Values: `443` | `1194`

  Default Value: `443`

## Properties

- `attrId`: string

- `authenticationOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientAuthenticationRequestProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientAuthenticationRequestProperty.html)[] — Information about the authentication method to be used to authenticate clients.

- `authorizationPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.AuthorizationPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.AuthorizationPolicyProperty.html)

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `clientCidrBlock`: string — The IPv4 address range, in CIDR notation, from which to assign client IP addresses.

- `clientConnectOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientConnectOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientConnectOptionsProperty.html) — The options for managing connection authorization for new client connections.

- `clientLoginBannerOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientLoginBannerOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientLoginBannerOptionsProperty.html) — Options for enabling a customizable text banner that will be displayed on AWS provided clients when a VPN session is established.

- `clientRouteEnforcementOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ClientRouteEnforcementOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ClientRouteEnforcementOptionsProperty.html) — Client route enforcement is a feature of the Client VPN service that helps enforce administrator defined routes on devices connected through the VPN.

- `clientVpnEndpointRef`: [ClientVpnEndpointReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ec2.ClientVpnEndpointReference.html) — A reference to a ClientVpnEndpoint resource.

- `connectionLogOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.ConnectionLogOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.ConnectionLogOptionsProperty.html) — Information about the client connection logging options.

- `creationStack`: string[]

- `description`: string — A brief description of the Client VPN endpoint.

- `devicePostureOptions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.DevicePostureOptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.DevicePostureOptionsProperty.html)

- `disconnectOnSessionTimeout`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the client VPN session is disconnected after the maximum `sessionTimeoutHours` is reached.

- `dnsServers`: string[] — Information about the DNS servers to be used for DNS resolution.

- `endpointIpAddressType`: string — The IP address type of the Client VPN endpoint.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `securityGroupIds`: string[] — The IDs of one or more security groups to apply to the target network.

- `selfServicePortal`: string — Specify whether to enable the self-service portal for the Client VPN endpoint.

- `serverCertificateArn`: string — The ARN of the server certificate.

- `sessionTimeoutHours`: number — The maximum VPN session duration time in hours.

- `splitTunnel`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether split-tunnel is enabled on the AWS Client VPN endpoint.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tagSpecifications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.TagSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.TagSpecificationProperty.html)[] — The tags to apply to the Client VPN endpoint during creation.

- `trafficIpAddressType`: string — The IP address type of the Client VPN endpoint.

- `transitGatewayConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnClientVpnEndpoint.TransitGatewayConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint.TransitGatewayConfigurationProperty.html)

- `transportProtocol`: string — The transport protocol to be used by the VPN session.

- `vpcId`: string — The ID of the VPC to associate with the Client VPN endpoint.

- `vpnPort`: number — The port number to assign to the Client VPN endpoint for TCP and UDP traffic.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForClientVpnEndpoint(resource: IClientVpnEndpointRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromClientVpnEndpointId(scope: Construct, id: string, clientVpnEndpointId: string): IClientVpnEndpointRef` (static) — Creates a new IClientVpnEndpointRef from a clientVpnEndpointId.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnClientVpnEndpoint(x: any): boolean` (static) — Checks whether the given object is a CfnClientVpnEndpoint.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
